clear; close all; clc;

%Clear all previous normfiles %
normfiles = dir('*norm*');
for i = 1:length(normfiles)
    delete(fullfile(normfiles(i).folder,normfiles(i).name));
end

files = dir('*.tif');
FinalImage=zeros(1024,1024,'uint16');
tilesize = [64 64 64];
MEANIMAGE = double(FinalImage);

for s = 1:length(files)
    FileTif = fullfile(files(s).folder,files(s).name);
    InfoImage=imfinfo(FileTif);
    NumberImages=length(InfoImage);
        
    TifLink = Tiff(FileTif,'r');
    for c = 2:NumberImages
        TifLink.setDirectory(c);
        FinalImage=double(TifLink.read());

        
        %% Correct for Illumination
        if c ~= 4
            Iillum = zeros(size(FinalImage));
            for i = 1:1024/tilesize(c)
                for j = 1:1024/tilesize(c)
                    tilex = max(tilesize(c)*(i-2)+tilesize(c)/2,1):min(tilesize(c)*i+tilesize(c)/2,1024);
                    tiley = max(tilesize(c)*(j-2)+tilesize(c)/2,1):min(tilesize(c)*j+tilesize(c)/2,1024);
                    tile = FinalImage(tilex,tiley);
                    %smoothtile = imgaussfilt(tile,1);
                    illum = prctile(tile(:),0.1);
                    Iillum(tilesize(c)*(i-1)+1:tilesize(c)*i,tilesize(c)*(j-1)+1:tilesize(c)*j) = FinalImage(tilesize(c)*(i-1)+1:tilesize(c)*i,tilesize(c)*(j-1)+1:tilesize(c)*j)-illum;

                end
            end
        
        
%         se = strel('disk',6);
%         Iopen = imopen(Iillum,se);
%         
%         figure(c); 
%         hold on;
%         [~,Idensity, Imesh,~] = kde(Iopen,2000);
%         plot(Imesh,Idensity);
%         pause;
        

        %% Subtract Background
            [~,Idensity, Imesh,~] = kde(Iillum,2000); %change kde filter size
            [pks,locs] = findpeaks(Idensity);
            Imaxloc = min(locs(pks>0.5*max(pks)));




            background = Imesh(Imaxloc);
            if background>0
                Inorm = Iillum - background;
            else
                Inorm = Iillum;
            end


            Inorm(Inorm<0) = 0;
            Inorm(Inorm>prctile(Inorm(:),99.9)) = prctile(Inorm(:),99.5);
        else
            Inorm = FinalImage;
        end

        Inorm = uint16(Inorm);
        [pathstr, name, ext] = fileparts(FileTif);
        imwrite(Inorm, fullfile(pathstr,strcat(name,'-norm.tif')),'WriteMode', 'append','Compression','none');
    end
    TifLink.close();
end

